paymentPage.extend( function() {

    if (paymentPage.view === "form") {
        if (typeof(paymentPage.pmethod)=='undefined') {
            paymentPage.pmethod = $("#pmethod").val();
        }
    }

    function checkMgcCard(ccnr)
    {
        var ll = 18;
        if (ccnr.length!=ll) return false;
        var iSuma = 0;
        for ( var i = 0; i < ll; i++ )
        {
            var strNum = ccnr.charAt(i);
            if ("1234567890".indexOf(strNum) < 0)
            {
                return false;
            }
            var iValue = parseInt(strNum);
            if (i % 2 === 0)
            {
                iValue = 3 * iValue;
            }
            iSuma = iSuma + iValue;
        }

        return iSuma % 10 === 0;
    }

    function checkCcValue(pan)
    {
        if (typeof(paymentPage.pmethod)=='undefined')
        {
             paymentPage.pmethod = document.payment.pmethod.value;
        }

        newPan = "";
        lPan = pan.length;
        for ( var i = 0; i < lPan; i++)
        {
            strNumber = pan.charAt(i);
            if ( strNumber != " " && strNumber != "-" ) newPan = newPan + strNumber;
        }

        pan = newPan;
        lPan = pan.length;

        if (lPan<4) return false;

        if (paymentPage.pmethod === "REK" )
        {
            if (lPan!=8) return false;
            return true;
        }

        if ((paymentPage.pmethod === "MPA")||(paymentPage.pmethod === "MPX")||(paymentPage.pmethod === "GFT"))
        {
            return true;
        }

        if ( paymentPage.pmethod === "MGC" )
        {
            if (checkMgcCard(pan)) return true;
            return false;
        }

        if (lPan<13) return false;


        // check branch

        brand = "none";
        if (typeof(document.payment.pmethod.length)!='undefined')
        {
            ll = document.payment.pmethod.length;
            for (i = 0; i < ll; i++)
            {
                if (document.payment.pmethod[i].checked)
                {
                    brand = document.payment.pmethod[i].value;
                }
            }
        }
        else
        {
            brand = document.payment.pmethod.value;
        }

        brand = brand.substring(0,3);

        if( $.inArray(brand, paymentPage.availablePaymentMethodCodes) == -1 ) return false;

        if ((brand=="VIS")&&((pan.substring(0,1)!="4")||(lPan<16))) return false;
        if ((brand=="UAP")&&((pan.substring(0,1)!="1")||(lPan<16))) return false;
        if ((brand!="VIS")&&(brand!="UAP"))
        {
            brandAr = paymentPage.checkBrandArr[brand];
            ident = pan.substring(0,2);
            if (typeof(brandAr)!='undefined')
            {
                if (brandAr.indexOf(ident)<0) return false;
            }
        }

        if (pan.indexOf('xxx')>0) return true; // masked CC

        // check modulo-10
        iSuma = 0;
        for (i = 0; i < lPan; i++)
        {
            strNumber = pan.charAt(lPan-i-1);

            if ("1234567890".indexOf(strNumber) < 0)
            {
                return false;
            }
            iValue = parseInt(strNumber);
            if ((i + 1) % 2 == 0)
            {
                iValue = 2 * iValue;
                if (iValue >= 10)
                {
                    iValue = 1 + iValue - 10;
                }
            }
            iSuma = iSuma + iValue;
        }

        if (! ((iSuma > 0)&&(iSuma % 10 == 0)))
        {
            return false;
        }

        return true;
    }

    function checkDate(dateStr)
    {
        var day;
        var month;
        var year;

		var match = dateStr.match( /^(\d{1,2})\.(\d{1,2})\.(\d{4})$/ );
		if ( match != null )
		{
			day = Number(match[1]);
			month = Number(match[2]-1);
			year = Number(match[3]);
		}
		else
		{
			match = dateStr.match( /^(\d{4})-(\d{1,2})-(\d{1,2})$/ );
			if ( match != null )
			{
				day = Number(match[3]);
				month = Number(match[2]-1);
				year = Number(match[1]);
			}
		}
		if ( match == null ) {
			return false;
		}
        var date = new Date( year, month, day );
        if ( date.getFullYear() !== year || date.getMonth() !== month || date.getDate() !== day ) {
            return false;
        }
        if (date.getTime() > new Date().getTime()) {
            return false;
        }
        return true;
    }

    function modulo( str, div )
    {
        var m = Number( str.substring( 0, 10 ) ) % div;
        return str.length <= 10 ? m : modulo( m + str.substring( 10 ), div );
    }

    function checkIban( iban )
    {
        if ( iban == null )
            return false;

        iban = iban.replace(/\s/g,"").toUpperCase();

        if ( iban.length == 0 || iban.length < 15 )
            return false;
        if ( iban.indexOf("DE") == 0 && iban.length !=22 )
            return false;

        iban = iban.substring(4) + iban.substring(0,4);

        var aux = "";
        for ( var i = 0; i < iban.length; i++ )
        {
            var charCode = iban.charCodeAt(i);
            if ( charCode >= 65 )
                aux += (charCode - 55);
            else
                aux += iban[i];
        }

        return modulo( aux, 97 ) == 1;
    }


    $.validator.addMethod("cardno", function( value, element ) {
        return this.optional(element) || checkCcValue( value );
    } );

    $.validator.addMethod("uppCustomerBirthDate", function( value, element ) {
        return this.optional(element) || checkDate( value );
    } );

    $.validator.addMethod( "bankDetailsValidator", function( val, element) {
        var bankaccount = $.trim($("input[name=bankaccount]").val());
        var bankrouting = $.trim($("input[name=bankrouting]").val());
        var bankiban = $.trim($("input[name=bankiban]").val());

        /* we need ( bankinban OR ( bankaccount AND bankrouting ) ) */

        if ( bankiban == "" && ( bankaccount == "" || bankrouting == "" ) ) return false;

        if ( bankiban != "" && bankaccount != "" && bankrouting != "" ) return false;

        if ( bankiban != "" && !checkIban(bankiban) ) return false;

        return true;
    } );

    $.validator.addMethod( "futureDate", function( value, element )
    {
        var expiryMonth = $.trim( $("select[name=expm]" ).val() );
        var expiryYear = $.trim( $("select[name=expy]" ).val() );

        if ( expiryMonth != "" && expiryYear != "" )
        {
            var today = new Date();

            var expiryDate = new Date();
            expiryDate.setMonth( parseInt(expiryMonth) - 1 );
            expiryDate.setFullYear( 2000 + parseInt(expiryYear) );

            return expiryDate.getTime() >= today.getTime();
        }

        return true;
    } );

    $.validator.addMethod("requiredForAccountsOutsideDE", function (val, element) {
        return $.trim($("input[name=accountNumber]").val().toUpperCase()).indexOf("DE") === 0;
    });

    $.validator.addMethod("iban", function (val, element) {
        return checkIban(val);
    });

    function addCharacterFilterMethod(methodName, characters) {
        $.validator.addMethod(methodName, function (value, element) {
            for( var i = 0; i < characters.length; i++ ) {
                var char = characters[i];
                if (value.indexOf(char) !== -1) {
                    $(element).data("forbiddenCharacter", char);
                    return false;
                }
            }
            return true;
        }, function (params, element) {
            return paymentPage.getTranslation("paym_invalid_character") + ": " + $(element).data("forbiddenCharacter");
        });
    }

    addCharacterFilterMethod("noForbiddenCharacters", paymentPage.forbiddenCharacters);
    addCharacterFilterMethod("noDigits", "0123456789");

    this.getValidationParams = function() {

        var validationRules = {
            cardno: { required: true, cardno: true },
            cvv: { required: paymentPage.mandatoryCVV, digits: true, minlength:3, maxlength:4 },
            expm: { required: true, futureDate: true, digits: true },
            expy: { required: true, futureDate: true, digits: true },
            bankaccount: { digits: true },
            bankrouting: { digits: true },
            bankiban: 	 { bankDetailsValidator: true },
            bankbic: {required: true, minlength: 8, maxlength: 11},
            sub_application: { required: true },
            uppCustomerBirthDate: { required: true, uppCustomerBirthDate: true },
            billPayDPR: { required: true },
            elvSepaDPR: { required: true },
            termsLinkBox: { required: true },
            mfgDPR: { required: true },
            accountNumber: {required: true, iban: true}, // BillPay IBAN
            bankCode: {requiredForAccountsOutsideDE: true}, // BillPay BIC
            mdpUserId: { required:true },
            uppCustomerEmail: { required: true, email: true },
            uppCustomerFirstName: {noForbiddenCharacters: true, noDigits: true },
            uppCustomerLastName: {noForbiddenCharacters: true, noDigits: true },
            uppCustomerStreet: {noForbiddenCharacters: true },
            uppCustomerZipCode: {noForbiddenCharacters: true },
            visaCtpEmail: {required:true, email: true},
            visaCtpOtp: {required:true, minlength:6, maxlength:6, digits:true }
        };

        var validationMessages = {
            cardno: paymentPage.getTranslation("paym_cardno_wrong"),
            cvv: {
                required: paymentPage.getTranslation("paym_cvv_missing"),
                digits: paymentPage.getTranslation("paym_cvv_not_numeric"),
                minlength: paymentPage.getTranslation("paym_cvv_minlength")
            },
            expm:
            {
                required: paymentPage.getTranslation("paym_expiry_missing"),
                futureDate: paymentPage.getTranslation("paym_future_date_invalid")
            },
            expy:
            {
                required: paymentPage.getTranslation("paym_expiry_missing"),
                futureDate: paymentPage.getTranslation("paym_future_date_invalid")
            },
            bankiban: {
                bankDetailsValidator: paymentPage.getTranslation("paym_elv_invalid_bank_parameters")
            },
            bankaccount: {
                digits: paymentPage.getTranslation("paym_bankaccount_not_numeric")
            },
            bankrouting: {
                digits:	paymentPage.getTranslation("paym_bankrouting_not_numeric")
            },
            bankbic: {
                minlength: paymentPage.getTranslation("paym_bankbic_minlength")
            },
            sub_application: { required : function() {
                if ( paymentPage.pmethod === "EPS" )
                    return paymentPage.getTranslation("paym_eps_select_bank");
                if ( paymentPage.pmethod === "DEA" || paymentPage.pmethod === "DII" )
                    return paymentPage.getTranslation("paym_ideal_select_bank");
            }  },
            accountNumber: {
                iban: paymentPage.getTranslation("paym_billpay_invalid_iban")
            },
            bankCode: {
                requiredForAccountsOutsideDE: paymentPage.getTranslation("paym_billpay_bic_mandatory_outside_de")
            },
            uppCustomerBirthDate: paymentPage.getTranslation("paym_date_wrong"),
            billPayDPR: paymentPage.getTranslation("paym_billpay_dpr_not_checked"),
            elvSepaDPR: paymentPage.getTranslation("paym_elv_sepa_not_checked"),
            termsLinkBox: paymentPage.getTranslation("paym_terms_link_box_not_checked"),
            mfgDPR: paymentPage.getTranslation("paym_mfg_dpr_not_checked"),
            uppCustomerEmail: paymentPage.getTranslation("paym_wrong_email"),
            visaCtpEmail: paymentPage.getTranslation("paym_wrong_email"),
            visaCtpOtp: paymentPage.getTranslation("paym_wrong_otp")
        };

        function setValidationObjectValue(object, field, rule, value) {
            if (typeof object[field] !== "object") {
                object[field] = {};
            }
            object[field][rule] = value;
        }

        $("#paymentForm").find(":input[name^=uppCustomer]").each( function() {
            var fieldName = $(this).attr("name");
            if ( fieldName !== "uppCustomerPhone" && fieldName !== "uppCustomerEmail"  && fieldName !== "uppCustomerBirthDate") {
                setValidationObjectValue(validationRules, fieldName,
                    "required", true);
                setValidationObjectValue(validationMessages, fieldName,
                    "required", paymentPage.getTranslation("paym_missing_parameters"));
            }
        });

        $("input[name=bankaccount],input[name=bankrouting],input[name=bankiban]").on("input", function() {
            var bankiban = $.trim($("input[name=bankiban]").val());
            var bankaccount = $.trim($("input[name=bankaccount]").val());
            var bankrouting = $.trim($("input[name=bankrouting]").val());
            $("input[name=bankaccount],input[name=bankrouting]").attr("disabled", bankiban===""?null:"disabled");
            $("input[name=bankiban]").attr("disabled", bankaccount===""&&bankrouting===""?null:"disabled");
        });

        $("input[name=bankiban]").mask('AAAA AAAA AAAA AAAA AAAA AAAA AAAA AAAA');

        return {
            rules: validationRules,
            groups: {expiry: "expm expy"},
            messages: validationMessages,
            onkeyup: false,
            ignore: "[type=hidden]",

            errorPlacement: function (error, element) {
                if (element.attr("name") == "expy" || element.attr("name") == "expm")
                    $("#expyField").after(error);
                else
                    error.insertAfter(element);
            },

            submitHandler: function (form) {
                var bankAccountInput = $(form).find("input[name=bankaccount]");
                if (bankAccountInput.length > 0) {
                    var bankAccountValue = bankAccountInput.val();
                    while (bankAccountValue.length < 10)
                        bankAccountValue = "0" + bankAccountValue;
                    bankAccountInput.val(bankAccountValue);
                }

                var bankRoutingInput = $(form).find("input[name=bankrouting]");
                if (bankRoutingInput.length > 0) {
                    var bankRoutingValue = bankRoutingInput.val();
                    while (bankRoutingValue.length < 8)
                        bankRoutingValue = "0" + bankRoutingValue;
                    bankRoutingInput.val(bankRoutingValue);
                }

                var visaCtPSignIn = $(form).find("input[name='visaCtpEmail']").length === 1;
                if(visaCtPSignIn){
                    return;
                }

                $("#payButton").attr("disabled", "disabled");

                if (paymentPage.startOnTop)
                    $(form).attr("target", "_top");

                form.submit();
            }
        };
    }
});
